/*-------------------------------------------------------------
 * ClassName :
 *     EclipseLauncher.java
 * 
 * Description :
 *     EclipseNNX
 * 
 * -----------------------------------------------------------
 * ύXF
 *  2003/12/02 o[W
 *  2004/02/13 Xi[Ci[NXɕύX
 * 
 *------------------------------------------------------------*/

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;


/**
 * @author M.Iwanaga
 *
 */
class EclipseLauncher extends JFrame	{

	private static String titleName = "EclipseLauncher";

	private JPanel buttonPanel;
	private JPanel textFieldPanel;
	private JPanel descriptionPanel;
	private JButton okButton;
	private JButton cancelButton;
	private JButton chooseButton;
	private JLabel descriptionLabel;
	private TextField textField;
	private String workplace = null;
	private String eclipsePath;
	private String defaultPath;
	private JFileChooser chooser;
	private int windowHeight = 150;
	private int windowWidth = 350;
	private int textFieldLength = 40;
	private int textFieldXLocation = 100;
	private int textFieldYLocation = 60;
	
	private ResourceBundle config;
	
	/**
	 * OK{^ANVXi[pC^[NX
	 */
	class OkButtonListener implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			workplace = textField.getText();
			run(workplace);
		}
    }
    
   /**
    * LZ{^ANVXi[pC^[NX
    */
    class CancelButtonListener implements ActionListener{
    	public void actionPerformed(ActionEvent e){
    		close();
    	}
    }
    
	/**
	 * t@CI{^ANVXi[pC^[NX
	 */
    class ChooseButtonListner implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			int returnVal = chooser.showOpenDialog(null);	
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				workplace = file.getPath();
				textField.setText(workplace);
			}
		}    	
    }
	
	/**
	 * RXgN^[
	 * @throws java.awt.HeadlessException
	 */
	EclipseLauncher(String eclipsePath, String defaultPath){
		
		super(titleName);
		
		/*
		 * eclipsePath  defaultPath ̃Zbg
		 */
		this.eclipsePath = eclipsePath;
		this.defaultPath = defaultPath;		
		
		/*
		 * I̐U镑w
		 */	
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		 
		/*
		 * pl 
		 */
		buttonPanel = new JPanel();
		textFieldPanel = new JPanel();
		descriptionPanel = new JPanel();
		
		
		/* 
		 * t@C`[U[
		 */
		chooser = new JFileChooser();
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		// X^[gʒǔ
		if (defaultPath != null) {
			File startDir = new File(defaultPath);
			chooser.setCurrentDirectory(startDir);		
		}
		
		/*
		 * 
		 */			
		descriptionLabel = new JLabel("workspace ̃pXw肵Ă");
		descriptionPanel.add(descriptionLabel);
		
		/*
		 * OK{^
		 */ 
		okButton = new JButton("OK");
		okButton.setActionCommand("ok");
		buttonPanel.add(okButton);
		
		/* 
		 * Cancel{^
		 */
		cancelButton = new JButton("LZ");
		cancelButton.setActionCommand("cancel");
		buttonPanel.add(cancelButton);
		
		/*
		 * Qƃ{^
		 */
		chooseButton = new JButton("I");
		chooseButton.setActionCommand("choose");
		buttonPanel.add(chooseButton);

		addActions();
		
		/*
		 * eLXgtB[h
		 */
		textField = new TextField(defaultPath, textFieldLength);
		textFieldPanel.add(textField);
		
		/*
		 * plt[ɔzu
		 */
		Container container = this.getContentPane();
		container.add(buttonPanel, BorderLayout.SOUTH);
		container.add(textFieldPanel, BorderLayout.CENTER);
		container.add(descriptionPanel, BorderLayout.NORTH);
		this.setSize(windowWidth, windowHeight);
		this.show();
		
		//long over = System.currentTimeMillis();
		//System.out.println("OVER  => " + over);
				
	}

	private void addActions(){
		ActionListener chooseButtonListener 
			= new ChooseButtonListner();
		chooseButton.addActionListener(chooseButtonListener);
		
		ActionListener cancelButtonListener
			= new CancelButtonListener();
		cancelButton.addActionListener(cancelButtonListener);
		
		ActionListener okButtonListener
			= new OkButtonListener();
		okButton.addActionListener(okButtonListener);
		
	}
	

	private void loadErrWindow(){
		ErrMsgWindow errWindow = new ErrMsgWindow();
		errWindow.setMsg("eclipse_path ̎w肪ł");
		errWindow.windowCreate();
		errWindow.setBounds( 10, 10, 400, 100);
		errWindow.setVisible(true);		
	}
	
	private void close(){
		this.dispose();
	}

	private void run(String dataPath){
		Runtime runtime = Runtime.getRuntime();
		String cmdline = eclipsePath + " -data " + dataPath;
		try {
			runtime.exec(cmdline);	
		} catch (IOException e) {
						
			e.printStackTrace();
		}
		catch (Exception e){
			loadErrWindow();
			e.printStackTrace();
		}
		finally {
			runtime.exit(0);
			this.dispose();
		}
	}
}